#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Crawler
# DIZ: Enables you to crawl for links to add to your Directory.
# GRAPHIC: ic_crawl.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use LWP::Simple;
use LWP::UserAgent;
use HTTP::Request; 
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";


####### SET UP TEMPORARY CRAWL DIRECTORY

if ((-e "$data_dir/crawler") < 1)
	{ 
	mkdir ("$data_dir/crawler", $default_permissions);
	chmod($default_permissions,"$data_dir/dbbackup","$data_dir/dbbackup");
	} 

######## SET UP GOOGLE URLS TO BE CRAWLED


$threads = $q->param('threads');
$timeout = $q->param('timeout');
$googlenr = $q->param('googlenr');
$keywords = $q->param('keywords');
$ccid = $q->param('ccid');

$metadiz = $q->param('metadiz');
$metakeyw = $q->param('metakeyw');


if ($threads eq "") { acs::problem_popup("You have to specify a number of threads."); exit; }
if ($timeout eq "") { acs::problem_popup("You have to specify a time-out value."); exit; }
if ($keywords eq "") { acs::problem_popup("You have to specify keywords to search for at Google.com"); exit; }
if ($googlenr < 1) { acs::problem_popup("The number of links to fetch at google.com has to be higher than 1"); exit; } 

$googlenr = int($googlenr / 10); obbuild::check_nr_tobe_crawled($googlenr);


$thread_connections = 0;
$file_counter = 0;
$globalc = 0;

$keywords =~ s/ /+/g;

for(my  $ms = 0; $ms <= $googlenr; $ms++ ) 
	{
	$pgnr = ($ms * 10);
	
	if ($thread_connections == 1)
		{
		$to_write = $to_write . "$globalc:---:http://www.google.com/search?&q=$keywords&btnG=Google+Search&start=$pgnr\n";
			
			$file_to_write = "$data_dir/crawler/G_" . $file_counter . "_" . $ccid . ".gle";
			open (GOOG, "> $file_to_write");
				print GOOG $to_write;
			close (GOOG);
		
		$to_write = "";
		$thread_connections = 0;
		$file_counter++;
		}
		else
		{
		$to_write = $to_write . "$globalc:---:http://www.google.com/search?&q=$keywords&btnG=Google+Search&start=$pgnr\n";
		}

	$thread_connections++;
	$globalc++;
	}

if ($to_write ne "")
	{
	$file_to_write = "$data_dir/crawler/G_" . $file_counter . "_" . $ccid . ".gle";
	open (GOOG, "> $file_to_write");
		print GOOG $to_write;
	close (GOOG);	
	}


$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Crawling Google For Links...", qq[
<img src="$web_url/working.gif">
]);


print qq[
<html>
<head>
<title></title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/pcrawl3.cgi?threads=$threads&timeout=$timeout&googlenr=$googlenr&keywords=$keywords&ccid=$ccid&nrfiles=$file_counter&metadiz=$metadiz&metakeyw=$metakeyw">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];









sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

